/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.138 by edhill, Sun Dec 4 13:57:08 2005 UTC revision 1.166 by jmc, Mon Oct 29 20:47:42 2007 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 248  build_cyrus_makedepend()  { Line 256  build_cyrus_makedepend()  {
256      fi      fi
257  }  }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 282  find_possible_configs()  { Line 325  find_possible_configs()  {
325    
326      #================================================================      #================================================================
327      #  look for possible C compilers      #  look for possible C compilers
328      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329      p_CC=      p_CC=
330      for c in $tmp ; do      for c in $tmp ; do
331          rm -f ./genmake_hello.c  ./genmake_hello          rm -f ./genmake_hello.c  ./genmake_hello
# Line 321  EOF Line 364  EOF
364    
365      #================================================================      #================================================================
366      #  look for possible FORTRAN compilers      #  look for possible FORTRAN compilers
367      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 gfortran"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 535  Usage: "$0" [OPTIONS] Line 578  Usage: "$0" [OPTIONS]
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587      -ts | --ts      -ts | --ts
588            Produce timing information per timestep            Produce timing information per timestep
589        -papis | --papis
590              Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593        -foolad | --foolad
594              Fool the AD code generator
595        -papi | --papi
596              Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599        -hpmt | --hpmt
600              Performance analysis with the HPM Toolkit
601    
602        -gsl | --gsl
603              Use GSL to control floating point rounding and precision
604        -devel | --devel
605              Add additional warning and debugging flags for development
606    
607      -mpi | --mpi      -mpi | --mpi
608            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
# Line 545  Usage: "$0" [OPTIONS] Line 611  Usage: "$0" [OPTIONS]
611            set to PATH. i.e. Include files from \$PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
612            from \$PATH/lib and use binaries from \$PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
613    
614        -es | --es | -embed-source | --embed-source
615              Embed a tarball containing the full source code
616              (including the Makefile, etc.) used to build the
617              executable [off by default]
618    
619      -bash NAME      -bash NAME
620            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
621    
# Line 685  EOF Line 756  EOF
756        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
757        end        end
758  EOF  EOF
759      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
760        echo $COMM >> genmake_warnings
761        $COMM >> genmake_warnings 2>&1
762      RET_F=$?      RET_F=$?
763      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
764      RETVAL=$?      RETVAL=$?
# Line 698  EOF Line 771  EOF
771    
772    
773  check_HAVE_SIGREG()  {  check_HAVE_SIGREG()  {
774        if test ! "x$HAVE_SIGREG" = x ; then
775            return
776        fi
777      get_fortran_c_namemangling      get_fortran_c_namemangling
778      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
779  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 755  EOF Line 831  EOF
831    
832    
833  check_HAVE_SETRLSTK()  {  check_HAVE_SETRLSTK()  {
834        if test "x$HAVE_SETRLSTK" = xt ; then
835            DEFINES="$DEFINES -DHAVE_SETRLSTK"
836            return
837        fi  
838        if test ! "x$HAVE_SETRLSTK" = x ; then
839            return
840        fi
841      get_fortran_c_namemangling      get_fortran_c_namemangling
842      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
843  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 865  EOF Line 948  EOF
948      cat genmake_tnc.F >> genmake_tnc.log      cat genmake_tnc.F >> genmake_tnc.log
949      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
950      RET_CPP=f      RET_CPP=f
951      COMM="$CPP $DEFINES $INCLUDES genmake_tnc.F"      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
952      echo "$COMM" >> genmake_tnc.log      echo "$COMM" >> genmake_tnc.log
953      $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t      eval $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
954      if test "x$RET_CPP" = xf ; then      if test "x$RET_CPP" = xf ; then
955          echo "  WARNING: CPP failed to pre-process the netcdf test." \          echo "  WARNING: CPP failed to pre-process the netcdf test." \
956              >> genmake_tnc.log              >> genmake_tnc.log
# Line 875  EOF Line 958  EOF
958              >> genmake_tnc.log              >> genmake_tnc.log
959      fi      fi
960      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
961      echo "  &&  $LINK -o genmake_tnc.o $LIBS" >> genmake_tnc.log      echo "  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
962      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
963          &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1          &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
964      RET_COMPILE=$?      RET_COMPILE=$?
965      cat genmake_tnc.log >> genmake_warnings      cat genmake_tnc.log >> genmake_warnings
966    
# Line 893  EOF Line 976  EOF
976      else      else
977          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
978          echo "try again with added '-lnetcdf'" > genmake_tnc.log          echo "try again with added '-lnetcdf'" > genmake_tnc.log
979          echo "$CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS \ " >> genmake_tnc.log          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
980          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
981          echo " &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log          echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
982          $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \          cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
983              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
984              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1              &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
985          RET_COMPILE=$?          RET_COMPILE=$?
986          cat genmake_tnc.log >> genmake_warnings          cat genmake_tnc.log >> genmake_warnings
987          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
988              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
989              HAVE_NETCDF=t              HAVE_NETCDF=t
990            else
991            # try again with "-lnetcdff" added to the libs
992                echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
993                echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
994                echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
995                echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
996                cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
997                    &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
998                    &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
999                RET_COMPILE=$?
1000                cat genmake_tnc.log >> genmake_warnings
1001                if test "x$RET_COMPILE" = x0 ; then
1002                    LIBS="$LIBS -lnetcdff -lnetcdf"
1003                    HAVE_NETCDF=t
1004                fi
1005          fi          fi
1006      fi      fi
1007      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 939  OPTFILE= Line 1037  OPTFILE=
1037  INCLUDES="-I. $INCLUDES"  INCLUDES="-I. $INCLUDES"
1038  FFLAGS=  FFLAGS=
1039  FOPTIM=  FOPTIM=
1040    FEXTRAFLAGS=
1041  CFLAGS=  CFLAGS=
1042  KFLAGS1=  KFLAGS1=
1043  KFLAGS2=  KFLAGS2=
# Line 950  NOOPTFLAGS= Line 1049  NOOPTFLAGS=
1049  MPI=  MPI=
1050  MPIPATH=  MPIPATH=
1051  TS=  TS=
1052    PAPIS=
1053    PCLS=
1054    FOOLAD=
1055    PAPI=
1056    PCL=
1057    HPMT=
1058    GSL=
1059    DEVEL=
1060  HAVE_TEST_L=  HAVE_TEST_L=
1061    
1062  # DEFINES checked by test compilation or command-line  # DEFINES checked by test compilation or command-line
# Line 957  HAVE_SYSTEM= Line 1064  HAVE_SYSTEM=
1064  HAVE_FDATE=  HAVE_FDATE=
1065  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1066  HAVE_CLOC=  HAVE_CLOC=
1067  HAVE_SETRLSTK=  # HAVE_SETRLSTK=
1068  HAVE_STAT=  HAVE_STAT=
1069  HAVE_NETCDF=  HAVE_NETCDF=
1070  HAVE_ETIME=  HAVE_ETIME=
# Line 974  BASH= Line 1081  BASH=
1081  PWD=`pwd`  PWD=`pwd`
1082  test "x$MAKE" = x  &&  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1083  test "x$AWK" = x   &&  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1084    EMBED_SRC=
1085  THISHOST=`hostname`  THISHOST=`hostname`
1086  THISCWD=`pwd`  THISCWD=`pwd`
1087  THISDATE=`date`  THISDATE=`date`
# Line 1007  TAMC_EXTRA= Line 1115  TAMC_EXTRA=
1115    
1116  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1117  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1118  gm_s2="FC CPP IEEE TS MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1119    
1120  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1121  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM FEXTRAFLAGS"
1122  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1123  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1124  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
# Line 1189  for ac_option in "$@" ; do Line 1297  for ac_option in "$@" ; do
1297    
1298          -ts | --ts)          -ts | --ts)
1299              TS=true ;;              TS=true ;;
1300            -papis | --papis)
1301                PAPIS=true ;;
1302            -pcls | --pcls)
1303                PCLS=true ;;
1304            -foolad | --foolad)
1305                FOOLAD=true ;;
1306            -papi | --papi)
1307                PAPI=true ;;
1308            -pcl | --pcl)
1309                PCL=true ;;
1310            -hpmt | --hpmt)
1311                HPMT=true ;;
1312    
1313            -gsl | --gsl)
1314                GSL=true ;;
1315    
1316            -devel | --devel)
1317                DEVEL=true ;;
1318    
1319          -mpi | --mpi)          -mpi | --mpi)
1320              MPI=true ;;              MPI=true ;;
# Line 1217  for ac_option in "$@" ; do Line 1343  for ac_option in "$@" ; do
1343          -ignoretime | -ignore_time | --ignoretime | --ignore_time)          -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1344              IGNORE_TIME="-DIGNORE_TIME" ;;              IGNORE_TIME="-DIGNORE_TIME" ;;
1345    
1346            -es | --es | -embed-source | --embed-source)
1347                EMBED_SRC=t ;;
1348    
1349          -*)          -*)
1350              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
1351              usage              usage
# Line 1235  done Line 1364  done
1364  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1365      echo      echo
1366      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1367      echo "  file.  This file format is no longer supported.  Please see:"      echo "  file.  This file format is no longer supported.  For directions on"
1368      echo      echo "  how to setup and use the new \"genmake2\" script, please see:"
1369      echo "    http://mitgcm.org/devel_HOWTO/"      echo "    http://mitgcm.org/devel_HOWTO/"
1370      echo      echo "  and send an email to MITgcm-support@mitgcm.org if you need help."
1371      echo "  for directions on how to setup and use the new \"genmake2\" input"      echo "WARNING: ignore \"./.genmakerc\" and continue."
     echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."  
1372      echo      echo
1373  fi  fi
1374    
1375  #  Find the MITgcm ${ROOTDIR}  #  Find the MITgcm ${ROOTDIR}
1376  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1377      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1378      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1379          ROOTDIR=".."          ROOTDIR=".."
1380      else      else
1381          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 1432  fi Line 1560  fi
1560    
1561  if test ! "x$TS" = x ; then  if test ! "x$TS" = x ; then
1562        echo "  Turning on timing per timestep"        echo "  Turning on timing per timestep"
1563        DEFINES="$DEFINES -DTIME_PER_TIMESTEP"        if test ! "x$FOOLAD" = x ; then
1564                DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1565          else
1566                DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1567          fi
1568          PACKAGES="$PACKAGES showflops"
1569    fi
1570    if test ! "x$PAPIS" = x ; then
1571          echo "  Turning on PAPI flop summary per timestep"
1572          echo "  Please make sure PAPIINC, PAPILIB are defined"
1573          if test ! "x$FOOLAD" = x ; then
1574                DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1575          else
1576                DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1577          fi
1578          INCLUDES="$INCLUDES $PAPIINC"
1579          LIBS="$LIBS $PAPILIB"
1580          PACKAGES="$PACKAGES showflops"
1581    fi
1582    if test ! "x$PCLS" = x ; then
1583          echo "  Turning on PCL counter summary per timestep"
1584          echo "  Please make sure PCLINC, PCLLIB are defined"
1585          if test ! "x$FOOLAD" = x ; then
1586                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1587          else
1588                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1589          fi
1590          INCLUDES="$INCLUDES $PCLINC"
1591          LIBS="$LIBS $PCLLIB"
1592          PACKAGES="$PACKAGES showflops"
1593    fi
1594    if test ! "x$PAPI" = x ; then
1595          if test ! "x$PAPIS" = x ; then
1596              echo "  PAPI performance analysis and flop summary per timestep cannot co-exist!"
1597              echo "  Sticking with PAPI flop summary per timestep!"
1598          else
1599              echo "  Turning on performance analysis with PAPI"
1600              echo "  Please make sure PAPIINC, PAPILIB are defined"
1601              DEFINES="$DEFINES -DUSE_PAPI"
1602              INCLUDES="$INCLUDES $PAPIINC"
1603              LIBS="$LIBS $PAPILIB"
1604          fi
1605    fi
1606    if test ! "x$PCL" = x ; then
1607          if test ! "x$PCLS" = x ; then
1608              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1609              echo "  Sticking with PCL flop summary per timestep!"
1610          else
1611              echo "  Turning on performance analysis with PCL"
1612              echo "  Please make sure PCLINC, PCLLIB are defined"
1613              DEFINES="$DEFINES -DUSE_PCL"
1614              INCLUDES="$INCLUDES $PCLINC"
1615              LIBS="$LIBS $PCLLIB"
1616          fi
1617    fi
1618    if test ! "x$HPMT" = x ; then
1619          if test ! "x$PAPI" = x ; then
1620              echo "  PAPI and the HPM Toolkit cannot co-exist!"
1621              echo "  Sticking with PAPI!"
1622          else if test ! "x$PCL" = x ; then
1623              echo "  PCL and the HPM Toolkit cannot co-exist!"
1624              echo "  Sticking with PCL!"
1625          else
1626              echo "  Turning on performance analysis with the HPM Toolkit"
1627              echo "  Please make sure HPMTINC, HPMTLIB are defined"
1628              DEFINES="$DEFINES -DUSE_LIBHPM"
1629              INCLUDES="$INCLUDES $HPMTINC"
1630              LIBS="$LIBS $HPMTLIB"
1631          fi
1632          fi
1633    fi
1634    if test ! "x$GSL" = x ; then
1635          echo "  Turning on use of GSL to control floating point calculations"
1636          echo "  Please make sure GSLINC, GSLLIB are defined"
1637          DEFINES="$DEFINES -DUSE_GSL_IEEE"
1638          INCLUDES="$INCLUDES $GSLINC"
1639          LIBS="$LIBS $GSLLIB"
1640  fi  fi
1641    
1642  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
# Line 1503  if test "x$HAVE_CLOC" != x ; then Line 1707  if test "x$HAVE_CLOC" != x ; then
1707      echo "yes"      echo "yes"
1708  else  else
1709      echo "no"      echo "no"
1710        if test "x$EMBED_SRC" = xt ; then
1711            echo "    WARNING: you requested file embedding but it has"
1712            echo "      been disabled since C code cannot be called"
1713            EMBED_SRC=
1714        fi
1715  fi  fi
1716  rm -f genmake_t*  rm -f genmake_t*
1717    
1718  printf "  Can we unlimit the stack size using $FC...  "  printf "  Can we unlimit the stack size using $FC...  "
1719  check_HAVE_SETRLSTK  check_HAVE_SETRLSTK
1720  if test "x$HAVE_SETRLSTK" != x ; then  if test "x$HAVE_SETRLSTK" = xt ; then
1721      echo "yes"      echo "yes"
1722  else  else
1723      echo "no"      echo "no"
# Line 1517  rm -f genmake_t* Line 1726  rm -f genmake_t*
1726    
1727  printf "  Can we register a signal handler using $FC...  "  printf "  Can we register a signal handler using $FC...  "
1728  check_HAVE_SIGREG  check_HAVE_SIGREG
1729  if test "x$HAVE_SIGREG" != x ; then  if test "x$HAVE_SIGREG" = xt ; then
1730      echo "yes"      echo "yes"
1731  else  else
1732      echo "no"      echo "no"
# Line 1542  else Line 1751  else
1751  fi  fi
1752  DEFINES="$DEFINES $IGNORE_TIME"  DEFINES="$DEFINES $IGNORE_TIME"
1753    
1754    if test "x$EMBED_SRC" = xt ; then
1755        build_embed_encode
1756    fi
1757    if test "x$EMBED_SRC" = xt ; then
1758        ENABLE="$ENABLE embed_files"
1759    fi
1760    
1761    
1762  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1763  printf "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1764  for d in $MODS ; do  for d in $MODS ; do
# Line 1627  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1844  if test -r $ROOTDIR"/eesupp/src/Makefile
1844      fi      fi
1845  fi  fi
1846    
1847  #same for exch2  #same for pkg/exch2 and pkg/regrid
1848  if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then  for pdir in exch2 regrid ; do
1849      echo "  Making source files in exch2 from  templates"      if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1850      ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1          echo "  Making source files in pkg/${pdir} from templates"
1851      RETVAL=$?          ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1852      if test "x${RETVAL}" = x0 ; then          RETVAL=$?
1853          rm -f make_exch2.errors          if test "x${RETVAL}" = x0 ; then
1854      else              rm -f make_${pdir}.errors
1855          echo "Error: problem encountered while building source files in exch2:"          else
1856          cat make_exch2.errors 1>&2              echo "Error: problem encountered while building source files in pkg/${pdir}:"
1857          exit 1              cat make_${pdir}.errors 1>&2
1858                exit 1
1859            fi
1860      fi      fi
1861  fi  done
1862    
1863  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1864  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
# Line 1750  done Line 1969  done
1969  rm -f ./.tmp_pack  rm -f ./.tmp_pack
1970  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1971    
1972  #  Check availability of NetCDF and then either build the MNC template  #  Check for package MNC: if NetCDF is available, then build the MNC
1973  #  files or delete mnc from the list of available packages.  #  template files ; otherwise, delete mnc from the list of packages.
1974  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1975  RETVAL=$?  RETVAL=$?
1976  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
# Line 1785  EOF Line 2004  EOF
2004      fi      fi
2005  fi  fi
2006    
2007    #  Check for package PROFILES: if NetCDF is not available,
2008    #  then delete profiles from the list of available packages.
2009    echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2010    RETVAL=$?
2011    if test "x$RETVAL" = x0 ; then
2012        if test "x$HAVE_NETCDF" != xt ; then
2013            cat <<EOF
2014    
2015    *********************************************************************
2016    WARNING: the "profiles" package was enabled but tests failed to
2017      compile NetCDF applications.  Please check that:
2018    
2019      1) NetCDF is correctly installed for this compiler and
2020      2) the LIBS variable (within the "optfile") specifies the correct
2021           NetCDF library to link against.
2022    
2023      Due to this failure, the "profiles" package is now DISABLED.
2024    *********************************************************************
2025    
2026    EOF
2027            PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2028            DISABLE="$DISABLE profiles"
2029        fi
2030    fi
2031    
2032  echo "  applying package dependency rules"  echo "  applying package dependency rules"
2033  ck=  ck=
2034  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
2035      i=0      i=0
2036      # rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
2037      rtot=$nname      rtot=$nname
2038      while test $i -lt $rtot ; do      while test $i -le $rtot ; do
2039    
2040          #  Is $pname in the current $PACKAGES list?          #  Is $pname in the current $PACKAGES list?
2041          #  pname=${PNAME[$i]}          #  pname=${PNAME[$i]}
# Line 1825  while test "x$ck" != xtt ; do Line 2069  while test "x$ck" != xtt ; do
2069    
2070          #  Do we need to add $dname according to the dependency rules?          #  Do we need to add $dname according to the dependency rules?
2071          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2072                #echo "   " $pname ": need to add :" $dname
2073              in_dis="f"              in_dis="f"
2074              for dis in $DISABLE ; do              for dis in $DISABLE ; do
2075                  if test "x$dis" = "x$dname" ; then                  if test "x$dis" = "x$dname" ; then
# Line 1993  for i in $INCLUDEDIRS ; do Line 2238  for i in $INCLUDEDIRS ; do
2238      fi      fi
2239  done  done
2240    
2241    if test ! "x$DIVA" = x ; then
2242        echo "  Creating the pseudo-MPI include directory"
2243        INCLUDES="-I./mpi_headers $INCLUDES"
2244        rm -rf ./mpi_headers
2245        mkdir -p ./mpi_headers
2246    
2247        if test "x$MPIINCLUDEDIR" = x ; then
2248            if test "x$MPIHOME" = x ; then
2249                MPIHOME='/usr'
2250            fi
2251            MPIINCLUDEDIR='$MPIHOME/include'
2252        fi
2253        
2254        if test -r $MPIINCLUDEDIR/mpif.h ; then
2255            for i in $MPI_HEADER_FILES; do
2256                cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2257            done
2258    
2259            perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2260        else
2261            echo " We cannot create a copy of mpif.h!"
2262    #       exit -1
2263        fi
2264    fi
2265    
2266  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2267  rm -rf .links.tmp  rm -rf .links.tmp
2268  mkdir .links.tmp  mkdir .links.tmp
2269    touch .links.tmp/foo
2270    if test ! -r ".links.tmp/foo" ; then
2271        echo
2272        echo "ERROR : something is wrong with your directory permissions or"
2273        echo "   your user file-creation mask (\"umask\") since creating a"
2274        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2275        echo "   not working.  Please try setting your umask to something"
2276        echo "   sane such as:"
2277        echo
2278        echo "      umask 0002"
2279        echo
2280        echo "   and please verify that you have the proper permissions for"
2281        echo "   creating sub-directories and then reading files created"
2282        echo "   within them."
2283        echo
2284        exit 1
2285    fi
2286    rm -f .links.tmp/foo
2287  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2288  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2289  printf 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
# Line 2014  for d in $alldirs ; do Line 2302  for d in $alldirs ; do
2302                  ignore_f=f                  ignore_f=f
2303                  case $d/$sf in                  case $d/$sf in
2304                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2305                            ignore_f=t
2306                          ;;                          ;;
2307                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2308                            ignore_f=t
2309                          ;;                          ;;
2310                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2311                            ignore_f=t
2312                          ;;                          ;;
2313                    ./BUILD_INFO.h)                    ./BUILD_INFO.h)
2314                            ignore_f=t
2315                            ;;
2316                      ./EMBEDDED_FILES.h)
2317                            ignore_f=t
2318                          ;;                          ;;
2319                    *)                    *)
2320                          #  For the local directory *ONLY*,                          #  For the local directory *ONLY*,
# Line 2132  DISABLED_PACKAGES = ${DISABLED_PACKAGES} Line 2427  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2427    
2428  # These files are created by Makefile  # These files are created by Makefile
2429  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2430  EOF  EOF
2431    
2432  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2433        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2434    else
2435        echo "EMBEDDED_FILES = " >>$MAKEFILE
2436    fi
2437    
2438    #  Note: figure out some way to add Hyades JAM libraries here
2439  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2440  # Unix ln (link)  # Unix ln (link)
2441  LN = ${LN}  LN = ${LN}
# Line 2163  INCLUDES = ${INCLUDES} Line 2462  INCLUDES = ${INCLUDES}
2462  KFLAGS1 = ${KFLAGS1}  KFLAGS1 = ${KFLAGS1}
2463  KFLAGS2 = ${KFLAGS2}  KFLAGS2 = ${KFLAGS2}
2464  # Optim./debug for FC  # Optim./debug for FC
2465  FFLAGS = ${FFLAGS}  FFLAGS = ${FFLAGS} ${FEXTRAFLAGS}
2466  FOPTIM = ${FOPTIM}  FOPTIM = ${FOPTIM}
2467  # Optim./debug for FC  # Optim./debug for FC
2468  F90FLAGS = ${F90FLAGS}  F90FLAGS = ${F90FLAGS}
# Line 2198  rm -f ad_flow_files.inc Line 2497  rm -f ad_flow_files.inc
2497  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2498    
2499  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2500  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2501          @echo Creating \$@ ...          @echo Creating \$@ ...
2502          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2503  depend:  depend:
# Line 2211  lib: libmitgcmuv.a Line 2510  lib: libmitgcmuv.a
2510    
2511  libmitgcmuv.a: \$(OBJFILES)  libmitgcmuv.a: \$(OBJFILES)
2512          ar rcv libmitgcmuv.a \$(OBJFILES)          ar rcv libmitgcmuv.a \$(OBJFILES)
2513            ar d   libmitgcmuv.a main.o
2514    
2515  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2516    
# Line 2221  output.txt: \$(EXECUTABLE) Line 2521  output.txt: \$(EXECUTABLE)
2521          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2522    
2523  clean:  clean:
2524          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2525            -rm -rf *.o
2526            -rm -rf *.$FS
2527  Clean:  Clean:
2528          @make clean          @make clean
2529          @make cleanlinks          @make cleanlinks
2530          -rm -f \$(SPECIAL_FILES)          -rm -f \$(SPECIAL_FILES)
2531          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
2532            -rm -f taf_command taf_output taf_ad.log taf_ad_flow.log
2533  CLEAN:  CLEAN:
2534          @make Clean          @make Clean
2535          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2536          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2537          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2538          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2539            -rm -f *_MIT_CE_000.opt0000 costfunction*0000
2540            -rm -rf mnc_test_*
2541    
2542  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2543  makefile:  makefile:
# Line 2260  test ! "x$THISUSER" = x && echo "      -echo Line 2565  test ! "x$THISUSER" = x && echo "      -echo
2565  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2566  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2567    
2568    if test "x$EMBED_SRC" = xt ; then
2569        cat >>$MAKEFILE <<EOF
2570    
2571    decode_files.o : EMBEDDED_FILES.h
2572    
2573    ##  \$(F77FILES)
2574    all_fF.tar.gz : \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2575            @echo Creating \$@ ...
2576            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2577            -rm -f all_fF.tar.gz
2578            -gzip all_fF.tar
2579    
2580    EMBEDDED_FILES.h : all_fF.tar.gz
2581            @echo Creating \$@ ...
2582            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2583    
2584    EOF
2585    fi
2586    
2587  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2588    
2589  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
# Line 2271  cat >>$MAKEFILE <<EOF Line 2595  cat >>$MAKEFILE <<EOF
2595          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2596  .$FS.o:  .$FS.o:
2597          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2598  .F90.$FS90:  .F90.o:  
         \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@  
 .$FS90.o:  
2599          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2600  .c.o:  .c.o:
2601          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2602    
2603  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2604  .F.p:  .F.p:
# Line 2300  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF Line 2622  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF
2622  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2623  for i in $ad_vars ; do  for i in $ad_vars ; do
2624      name=$i      name=$i
2625      t1="t2=\$"`echo $i`      t1="t2=\$"`echo "$i"`
2626      eval $t1      eval $t1
2627      printf "%-20s = " $name >> $MAKEFILE      printf "%-20s = " $name >> $MAKEFILE
2628      echo $t2 >> $MAKEFILE      echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2629  done  done
2630    
2631  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
# Line 2320  rm -f ad_files Line 2642  rm -f ad_files
2642  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2643    
2644  # ... AD ...  # ... AD ...
2645  adall: ad_taf  adall: \$(EXE_AD)
2646  adtaf: ad_taf_output.$FS  adtaf: ad_taf_output.$FS
2647  adtamc: ad_tamc_output.$FS  adtamc: ad_tamc_output.$FS
2648    
# Line 2340  adtafonly: Line 2662  adtafonly:
2662          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2663          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2664    
2665  ad_taf: ad_taf_output.o \$(OBJFILES)  \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2666          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2667    
2668  ad_tamc_output.$FS: ad_input_code.$FS  ad_tamc_output.$FS: ad_input_code.$FS
2669          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS

Legend:
Removed from v.1.138  
changed lines
  Added in v.1.166

  ViewVC Help
Powered by ViewVC 1.1.22